/* -*- c++ -*- */
/* 
 * This file is part of liblot
 * Copyright (C) 2008 Erik Lotspeich <erik@lotspeich.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation: version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include "liblot_args.h"

void liblot::args::getlopt::process_args()
{
	typedef std::map<std::string, option *>::iterator MI;

	for (int i = 1; i < ah_argc; i++) {
		MI mi = reg_opts.find(ah_argv[i]);

		if (mi == reg_opts.end()) {
			/* Handle opt not found (i.e. not registered for) */
			option opt;
			opt.set_opt(ah_argv[i]);

			if (opth_nf) opth_nf->handle(opt);
		} else {
			/* Handle registered opts */
			option *opt = mi->second;
			
			opt->set_opt(ah_argv[i]);
			if (opt->get_takes_arg()) {
				if (ah_argv[++i]) opt->set_optarg(ah_argv[i]);
			}
			
			opt->handle_opt();
		}
	}
}
