/* -*- c++ -*- */
/* 
 * This file is part of liblot
 * Copyright (C) 2008 Erik Lotspeich <erik@lotspeich.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation: version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <string>
#include <cstdio>

#include "liblot_profile.h"
#include "liblot_exception.h"

const std::string liblot::profile::stopwatch::PROC_UPTIME_FILE("/proc/uptime");

double liblot::profile::stopwatch::get_uptime()
{
        FILE *fp = NULL;
        double uptime = ERROR, idletime = ERROR;

        if ((fp = fopen(PROC_UPTIME_FILE.c_str(), "r")) == NULL) return(ERROR);
        fscanf(fp,"%le %le\n", &uptime, &idletime);
        fclose(fp);

        return(uptime);
}

long liblot::profile::stopwatch::get_uptime_ms()
{
        return((long)(get_uptime() * 1000));
}
