/* -*- c++ -*- */
/* 
 * This file is part of liblot
 * Copyright (C) 2008 Erik Lotspeich <erik@lotspeich.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation: version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <iostream>
#include <fstream>
#include <string>

#include "liblot_cmd.h"

int main(int argc, char **argv)
{
	using namespace liblot::cmd;

	std::list<std::string> args;

        cmd_parms parms("/home/erik/dkim-verify/src/ioprint", args);
        //cmd_parms parms("/bin/cat", args);
        cmd_opts opts(cmd_opts::OPT_INPUT | cmd_opts::OPT_OUTPUT);
        //exec_cmd *e = new_exec_cmd(EXEC_IMPL_PIPE, parms, opts);
        exec_cmd *e = new_exec_cmd(EXEC_IMPL_FILE, parms, opts);

	if (! ((argc > 1) && *argv[1])) {
		std::cerr << "usage: test <filename>" << std::endl;
		return(-1);
	}

	std::streampos length;
	char *buffer = 0;

	std::ifstream is;
	is.open(argv[1], std::ios::binary);

  	is.seekg (0, std::ios::end);
  	length = is.tellg();
  	is.seekg (0, std::ios::beg);

	std::cout << "file size: " << length << std::endl;

	if (length > 0) {
		buffer = new char [length];

		is.read(buffer, length);
		is.close();
		
		std::cerr << "read into buffer" << std::endl;

		e->write_to_cmd(std::string(buffer, length));

		std::cerr << "wrote to e" << std::endl;
	}

	e->exec();

	std::cerr << "after exec" << std::endl;

	std::cout << e->read_from_cmd();

	delete[] buffer;
	delete e;

	return(0);
}
